function encode_thing(x)
	if type(x) == "number" then return tostring(x)
	elseif type(x) == "string" then return string.format("%q", x):gsub("\\\n", "\n")
	elseif type(x) == "boolean" then
		if x == true then
			return "True"
		else
			return "False"
		end
	elseif type(x) == "table" then
		return table_to_str(x)
	end
end

function decode_string(x) -- TODO-future: can this be done in a better way?
	f = loadstring("return " .. x)
	if f then
		return f()
	else
		return nil
	end
end

function decode_thing(x)
	local num = tonumber(x)
	if num then return num end
	if x == "True" then return true end
	if x == "False" then return false end
--~ 	if x == nil then -- TODO: Hack, it's a bug when this happens
--~ 		print("Error decoding string, x = nil")
--~ 		return "nil"
--~ 	end
	local str = x:match([[^"(.*)"$]]) -- TODO-future: redo these in some other way?
	if str then
		s = decode_string(x)
		if s then return s end
	end
	local tblstr = x:match([[^(%[.+%])$]]) -- TODO-future: redo these in some other way?
	if tblstr then return str_to_table(tblstr) end
	local eff1, eff2, eff3 = x:match([[^%("(.-)", *([0-9]-), *"(.-)"%)$]])
	if eff1 and eff2 and eff3 then
		return { eff1, eff2, eff3 }
	end
	print("error: can't decode table value", x)
end

function table_to_str(tbl)
	local newtbl = {}
	local keys = {}
	for from, to in pairs(tbl) do
		table.insert(keys, from)
	end
	table.sort(keys)
	for _, from in pairs(keys) do
		local to = tbl[from]
--~ 		print("tbl["..tostring(from).."] -> "..tostring(to))
		table.insert(newtbl, string.format("(%s, %s)", encode_thing(from), encode_thing(to)))
	end
	return "["..table.concat(newtbl, ", ").."]"
end

function str_to_table(str) -- TODO: redo properly!
	local tbl = {}
--~ 	print("str_to_table("..str..")")
	for x in string.gmatch(str, "%b()") do
--~ 		print(x)
		a, b = x:match([[^%(("[^"]*,[^"]*"), *([0-9]+)%)$]]) -- ugly hack for e.g. Go Get 'Em, Tiger!
		if not b then
			a, b = x:match([[^%((.-), *(.+)%)$]]) -- TODO-future: redo regex?
		end
--~ 		print("decoding", a, "->", b)
		tbl[decode_thing(a)] = decode_thing(b)
	end
--~ 	print("returning", table_to_str(tbl))
	return tbl
end

function parse_params_raw(str)
	local loadstr = parse_table_string(str)
	if loadstr == "" then
		return nil
	else
		local tbl = assert(loadstring(loadstr))()
		if table.maxn(tbl) == 0 then
			return nil
		else
			return tbl
		end
	end
end

function parse_params(str)
	local rawtbl = parse_params_raw(str)
	local tbl = {}
	for _, x in pairs(rawtbl or {}) do
		tbl[x.key] = x.value
	end
	return tbl
end

function printstr(tbl)
	if tbl == nil then
		return tostring(tbl)
	elseif type(tbl) == "table" then
		return table_to_str(tbl)
	else
		return tostring(tbl)
	end
end

function get_daily_counter(name)
	local value = get_day_state(name)
	if (value == "") then value = 0 end
	return tonumber(value)
end

function increase_daily_counter(name, amount)
	local increase = (amount or 1)
	set_day_state(name, get_daily_counter(name) + increase)
end

local familiar_counters = {}
local infolines = {}
local values = {}

function print_familiar_counter(compact, normal)
	if string.match(text, "<!%-%- charpane compact") then
		table.insert(familiar_counters, compact)
	else
		table.insert(familiar_counters, normal)
	end
end

function print_charpane_infoline(compact, normal)
	if string.match(text, "<!%-%- charpane compact") then
		table.insert(infolines, compact)
	else
		table.insert(infolines, normal)
	end
end

function print_charpane_value(value)
	table.insert(values, value)
end

function print_charpane_lines()
	if text:match("http://images.kingdomofloathing.com/otherimages/inf_small.gif") then return end
	if string.match(text, "<!%-%- charpane compact") then -- compact mode
		local lines = {}
		for x,y in pairs(familiar_counters) do table.insert(lines, y) end
		for x,y in pairs(infolines) do table.insert(lines, y) end

		for x,y in pairs(lines) do
			if string.match(text, "</table>(<!%-%- charpane compact familiar text space type%b{} weight%b{} %-%->)") then
				text = string.gsub(text, "(<!%-%- charpane compact familiar text space type%b{} weight%b{} %-%->)", function(one) return y .. one end)
			else
				text = string.gsub(text, "(<!%-%- charpane compact familiar text space type%b{} weight%b{} %-%->)", function(one) return "<br>" .. y .. one end)
			end
		end
		for x,y in pairs(values) do
			local name = y["name"] or "{nil}"
			local value = y["value"] or "{nil}"
			local ct = "<td align=right>" .. name .. ":</td><td align=left><b>" .. value .. "</b></td>"
			local style = ""
			if y["color"] then
				style = " style=\"color:" .. y["color"] .. "\""
			end
			if y["link"] then
				ct = [[<td align=right><a target="mainpane" href="]] .. y["link"] .. [["]] .. style .. [[>]] .. name .. [[</a>:</td><td align=left><a target="mainpane" href="]] .. y["link"] .. [["]] .. style .. [[><b>]] .. value .. [[</b></a></td>]]
			end
			if y["tooltip"] then
				ct = "<tr title=\"" .. y["tooltip"] .. "\"" .. style .. ">" .. ct .. "</tr>"
			else
				ct = "<tr" .. style .. ">" .. ct .. "</tr>"
			end
			text = string.gsub(text, "(<!%-%- charpane compact text space %-%->)", function(one) return ct .. one end)
		end
	else -- normal mode
		local lines = {}
		for x,fc in pairs(familiar_counters) do table.insert(lines, tostring(fc)) end
		for x,il in pairs(infolines) do table.insert(lines, tostring(il)) end

		for x,l in pairs(lines) do
			text = string.gsub(text, "(<!%-%- charpane normal familiar text space type%b{} weight%b{} %-%->)", function(one) return "<tr><td colspan=\"2\"><center><font size=\"2\">" .. l .. "</font></center></td></tr>" .. one end)
		end
		for x,y in pairs(values) do
			local name = y["name"] or "{nil}"
			local value = y["value"] or "{nil}"
			local nt = "<font size=\"2\">" .. name .. ": <b>" .. value .. "</b></font>"
			local style = ""
			if y["color"] then
				style = " style=\"color:" .. y["color"] .. "\""
			end
			if y["link"] then
				nt = [[<font size="2"><a target="mainpane" href="]] .. y["link"] .. [["]] .. style .. [[>]] .. name .. [[: <b>]] .. value .. [[</b></a></font>]]
			end
			if y["tooltip"] then
				nt = "<span title=\"" .. y["tooltip"] .. "\"" .. style .. ">" .. nt .. "</span>"
			else
				nt = "<span" .. style .. ">" .. nt .. "</span>"
			end
			text = string.gsub(text, "(<!%-%- charpane normal text space %-%->)", function(one) return nt .. "<br>" .. one end)
		end
	end
end

function get_mainstat()
	classname = get_session_state("class")
	if classname == "1" or classname == "2" then
		return "Muscle"
	elseif classname == "3" or classname == "4" then
		return "Mysticality"
	elseif classname == "5" or classname == "6" then
		return "Moxie"
	end
end

--~ function get_request_state(name) return get_state("request", name) end
function get_fight_state(name) return get_state("fight", name) end
function get_session_state(name) return get_state("session", name) end
function get_day_state(name) return get_state("day", name) end
function get_ascension_state(name, value) return get_state("ascension", name) end
function get_character_state(name) return get_state("character", name) end

--~ function set_request_state(name, value) set_state("request", name, value) end
function set_fight_state(name, value) set_state("fight", name, value) end
function set_session_state(name, value) set_state("session", name, value) end
function set_day_state(name, value) set_state("day", name, value) end
function set_ascension_state(name, value) set_state("ascension", name, value) end

raw_submit_page = submit_page

function do_submit_page(t, url, params)
	if params then
		local tbl = {}
		for a, b in pairs(params) do
			table.insert(tbl, { key = a, value = b })
		end
		return raw_submit_page(t, url, tbl)
	else
		return raw_submit_page(t, url, nil)
	end
end

function get_page(url, params) return do_submit_page("GET", url, params) end

function post_page(url, params) return do_submit_page("POST", url, params) end

function get_itemid(name)
	local num = tonumber(str_to_table(get_item_data_by_name(name)).id)
	if num == nil then
		print("Error! No itemid found for item", name)
	end
	return num
end

function caching_get_itemid(name) -- TODO: would be better it get_item_data_by_name wasn't slow
	local tbl = get_session_state("cached itemids")
	if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
	if not tbl[name] then
		tbl[name] = tonumber(str_to_table(get_item_data_by_name(name)).id)
		set_session_state("cached itemids", table_to_str(tbl))
	end
	return tbl[name]
end

if set_state then
	get_itemid = caching_get_itemid
end







dod_potion_types = {
	"bubbly potion",
	"cloudy potion",
	"dark potion",
	"effervescent potion",
	"fizzy potion",
	"milky potion",
	"murky potion",
	"smoky potion",
	"swirly potion",
}

dod_potion_effects = {
	"acuity",
	"blessing",
	"booze",
	"confusion",
	"detection",
	"healing",
	"sleep",
	"strength",
	"teleportation",
}

function get_dod_potion_status()
--~ 	print("get potion status")
	local tbl = get_ascension_state("zone.dod.potions")
	if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
	unknown_potions = {}
	for _, pot in pairs(dod_potion_types) do
		if not tbl[pot] then
			table.insert(unknown_potions, pot)
		end
	end

	found = {}
	for pot, eff in pairs(tbl) do
		found[eff] = pot
	end

	unknown_effects = {}
	for _, eff in pairs(dod_potion_effects) do
		if not found[eff] then
			table.insert(unknown_effects, eff)
		end
	end

	if table.maxn(unknown_effects) == 1 and table.maxn(unknown_potions) == 1 then -- only one missing effect and one missing potion
		tbl[unknown_potions[1]] = unknown_effects[1]
		return tbl, {}
	else
--~ 		print("unknown effects", table.maxn(unknown_effects), table_to_str(unknown_effects))
--~ 		print("unknown potions", table.maxn(unknown_potions), table_to_str(unknown_potions))
		return tbl, unknown_potions
	end
end




function get_bufflist()
	local status = str_to_table(get_status_info())
	local effects = str_to_table(status.effects)
	local buffslist = {}
	for _, x in pairs(effects) do
		buffslist[x[1]] = tonumber(x[2])
	end
	return buffslist
end


function run_file_with_environment(filename, env)
	setmetatable(env, { __index = function(t, k)
		local v = _G[k]
		local ignore = {
			string = true,
			tonumber = true,
			tostring = true,
			pairs = true,
			next = true,
			print = true,
			table = true,
		}
		if not ignore[k] then
--~ 			print("__index", t, k, filename)
		end
		return v
	end })
--~ 	setmetatable(env, { __index = _G })
	local f, e = loadfile("scripts/" .. filename)
	if not f then error(e, 2) end
	setfenv(f, env)
	f()
end

--~ function run_file_with_environment(filename, env)
--~ 	for a,b in pairs(env) do
--~ 		_G[a] = b
--~ 	end
--~ 	dofile("scripts/" .. filename)
--~ end


function set_ascension_turn_counter(name, length)
	local tbl = get_ascension_state("turn counters")
	if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
	table.insert(tbl, table_to_str{ name = name, turn = tonumber(get_turns_this_run()), length = length })
	set_ascension_state("turn counters", table_to_str(tbl))
end





function get_drunkenness()
--~ 	local drunk = tonumber(tbl["drunkenness"])
	return 0 -- TODO: hack!
--~ 	return drunk
end

function do_we_have_mall_access()
	return true -- TODO: hack!
end








function setup_functions(skip_refreshing)
	inventory = nil
	status = nil
	buffslist = nil
	function refresh()
		status = str_to_table(get_status_info())
		buffslist = {}
		local effects = str_to_table(status.effects)
		for _, x in pairs(effects) do
			buffslist[x[1]] = tonumber(x[2])
		end
	end
	function refresh_inv()
		inventory = str_to_table(get_inventory_counts())
	end

--~ function level() return tonumber(status.level) end -- doesn't work because CDM moyered it
	function level()
		if basemainstat() < 4 then
			return 1
		else
			return 1 + math.floor(math.sqrt(basemainstat() - 4))
		end
	end

	function have(name)
		return inventory[get_itemid(name)]
	end

	function meat() return tonumber(status.meat) end
	function hp() return tonumber(status.hp) end
	function mp() return tonumber(status.mp) end
	function maxhp() return tonumber(status.maxhp) end
	function maxmp() return tonumber(status.maxmp) end
	function turnsthisrun() return tonumber(status.turnsthisrun) end
	function familiarid() return tonumber(status.familiar) end
	function buff(name) return buffslist[name] end
	function buffturns(name) return buffslist[name] or 0 end
	function advs() return tonumber(status.adventures) end
	function basemuscle() return tonumber(status.basemuscle) end
	function basemysticality() return tonumber(status.basemysticality) end
	function basemoxie() return tonumber(status.basemoxie) end
	function buffedmainstat() return tonumber(status[string.lower(get_mainstat())]) end
	function basemainstat() return tonumber(status["base" .. string.lower(get_mainstat())]) end
	function equipment() return str_to_table(status.equipment) end

	function count(name)
		return inventory[get_itemid(name)] or 0
	end

	function plunge_items(a, b)
		local pwd = get_session_state("pwd") -- inserting pwd, boo!
		return post_page("/knoll.php", { action = "combine", pwd = pwd, item1 = tostring(get_itemid(a)), item2 = tostring(get_itemid(b)), quantity = "1", ajax = "1" })
	end

	function equip_itemid(id, slot)
		local pwd = get_session_state("pwd") -- inserting pwd, boo!
		local tbl = { pwd = pwd, action = "equip", whichitem = tostring(id), ajax = "1" }
		if slot then
			tbl.slot = tostring(slot)
		end
		return get_page("/inv_equip.php", tbl)
	end

	function unequip_slot(name)
		local pwd = get_session_state("pwd") -- inserting pwd, boo!
		return get_page("/inv_equip.php", { pwd = pwd, action = "unequip", type = name, ajax = "1" })
	end

	function use_itemid(id, amount)
		local pwd = get_session_state("pwd") -- inserting pwd, boo!
		if amount then
			return get_page("/multiuse.php", { pwd = pwd, whichitem = tostring(id), ajax = "1", quantity = tostring(amount), action = "useitem" })
		else
			return get_page("/inv_use.php", { pwd = pwd, whichitem = tostring(id), ajax = "1" })
		end
	end

	function use_itemid_noajax(id, amount)
		local pwd = get_session_state("pwd") -- inserting pwd, boo!
		if amount then
			return get_page("/multiuse.php", { pwd = pwd, whichitem = tostring(id), quantity = tostring(amount), action = "useitem" })
		else
			return get_page("/inv_use.php", { pwd = pwd, whichitem = tostring(id) })
		end
	end

	function use_item(name, amount)
		return use_itemid(get_itemid(name), amount)
	end

	function use_item_noajax(name, amount)
		return use_itemid_noajax(get_itemid(name), amount)
	end

	function eat_item(name)
		local pwd = get_session_state("pwd") -- inserting pwd, boo!
		return get_page("/inv_eat.php", { pwd = pwd, which = "1", whichitem = tostring(get_itemid(name)), ajax = "1" })
	end

	function equip_item(name, slot)
		return equip_itemid(get_itemid(name), slot)
	end

--~ 	function pull_itemids(xs)
--~ 		local pwd = get_session_state("pwd") -- inserting pwd, boo!
--~ 		local tbl = { pwd = pwd, action = "take" }
--~ 		for nr, id in pairs(xs) do
--~ 			tbl["howmany" .. tostring(nr)] = "1"
--~ 			tbl["whichitem" .. tostring(nr)] = tostring(id)
--~ 		end
--~ 		-- split up more than 11
--~ 		return post_page("/storage.php", tbl)
--~ 	end

	function freepull_itemid(id)
		local pwd = get_session_state("pwd") -- inserting pwd, boo!
		return post_page("/storage.php", { action = "freepull", pwd = pwd, quantity = "1", whichitem = tostring(id) })
	end

	function sell_itemid(id, amount)
	--~ posting page /sellstuff_ugly.php params: Just [("pwd","e3f1e243cb8a9668f0abf68875aa436f"),("action","sell"),("mode","3"),("quantity","1"),("item705","705")]
		local pwd = get_session_state("pwd") -- inserting pwd, boo!
		return post_page("/sellstuff_ugly.php", { pwd = pwd, action = "sell", mode = "3", quantity = tostring(amount), ["item"..tostring(id)] = tostring(id) })
	end

	function cast_buff(skillid, quantity, targetid)
	--~ got uri: /skills.php | ?whichskill=6015&quantity=2&ajax=1&action=Skillz&ref=1&targetplayer=1564433&pwd=c52682cbfb2ed7825b5b479e76b36c35&_=1280787995838 (from /skills.php?whichskill=6015&quantity=2&ajax=1&action=Skillz&ref=1&targetplayer=1564433&pwd=c52682cbfb2ed7825b5b479e76b36c35&_=1280787995838), size 880
		local pwd = get_session_state("pwd") -- inserting pwd, boo!
		targetid = targetid or get_session_state("playerid")
		assert(targetid and targetid ~= "")
		local tbl = { whichskill = tostring(skillid), ajax = "1", action = "Skillz", pwd = pwd, targetplayer = tostring(targetid) }
		if quantity then tbl.quantity = tostring(quantity) end
		return get_page("/skills.php", tbl)
	end

	function switch_familiarid(id)
		return get_page("/familiar.php", { action = "newfam", ajax = "1", newfam = tostring(id) })
	end

	function handle_adventure_result(pt, url, zoneid, macro, noncombatchoices, specialnoncombatfunction)
		if url:match("/fight.php") then -- TODO: hmmmm? -- and url:match("ireallymeanit") then
			local advagain = nil
			if pt:match([[>You win the fight!<!%-%-WINWINWIN%-%-><]]) then
				advagain = true
			elseif pt:match([[state['fightover'] = true;]]) then
				if pt:match("You lose.") then
					advagain = false
				elseif pt:match([[<a href="adventure.php%?snarfblat=]]..zoneid..[[">Adventure Again]]) then
					advagain = true
				end
			end
			if advagain == nil then
				if macro then
					local pt, url = post_page("/fight.php", { action = "macro", macrotext = macro })
					return handle_adventure_result(pt, url, zoneid, nil, noncombatchoices, specialnoncombatfunction)
				else
					print("fight.php unhandled url", url)
				end
			end
			return pt, url, advagain
		elseif url:match("/choice.php") then
			local adventure_title = pt:match([[<tr><td style="color: white;" align=center bgcolor=blue><b>([^<]*)</b></td></tr>]])
			if adventure_title == "Results:" then
				if pt:match([[<a href="adventure.php%?snarfblat=]]..zoneid..[[">Adventure Again]]) then
					advagain = true
				end
				return pt, url, advagain
			end
			local choice_adventure_number = tonumber(pt:match([[<input type=hidden name=whichchoice value=([0-9]+)>]]))
	--~ 		print("choice", adventure_title, choice_adventure_number)
			local pickchoice = nil
			local optname = nil
			if specialnoncombatfunction then
				optname, pickchoice = specialnoncombatfunction(adventure_title, choice_adventure_number)
			else
				optname = noncombatchoices[adventure_title]
			end
			if optname and not pickchoice then
				for nr, title in pt:gmatch([[<input type=hidden name=option value=([0-9])><input class=button type=submit value="([^>]+)">]]) do
		--~ 			print("opt", nr, title)
					if title == optname then
						pickchoice = tonumber(nr)
					end
				end
			end
			if pickchoice then
				local pwd = get_session_state("pwd") -- inserting pwd, boo!
				local pt, url = post_page("/choice.php", { pwd = pwd, whichchoice = tostring(choice_adventure_number), option = tostring(pickchoice) })
				print("choice ->", url)
				return handle_adventure_result(pt, url, zoneid, macro, noncombatchoices, specialnoncombatfunction)
			else
				print("choice", adventure_title, choice_adventure_number)
				for nr, title in pt:gmatch([[<input type=hidden name=option value=([0-9])><input class=button type=submit value="([^>]+)">]]) do
					print("opt", nr, title)
				end
				return pt, url, false
			end
		else
			local advagain = false
			if pt:match([[<a href="adventure.php%?snarfblat=]]..zoneid..[[">Adventure Again]]) then
				advagain = true
			else
				print("non-fight non-choice unhandled url", url)
			end
			return pt, url, advagain
		end
	end

	function autoadventure(zoneid, macro, noncombatchoices, specialnoncombatfunction)
		set_fight_state("zone", zoneid)
		set_ascension_state("adventure.lastzone", zoneid)
		if not noncombatchoices then noncombatchoices = {} end
		local pt, url = post_page("/adventure.php", { snarfblat = tostring(zoneid) })
		return handle_adventure_result(pt, url, zoneid, macro, noncombatchoices, specialnoncombatfunction)
	end

	if skip_refreshing ~= true then
		refresh()
		refresh_inv()
	end
end
