io = nil
os = nil
debug = nil
require = nil
module = nil
package = nil

if can_read_state() ~= "yes" then
	return text
end

dofile("scripts/base/util.lua")

input_params = params
params = parse_params(params)

local processors = {}
local printers = {}
noncombat_choice_texts = {}

local function add_processor_raw(scriptname, file, func)
	if not processors[file] then processors[file] = {} end
	table.insert(processors[file], { scriptname = scriptname, f = func })
end

local function add_printer_raw(scriptname, file, func)
	if not printers[file] then printers[file] = {} end
	table.insert(printers[file], { scriptname = scriptname, f = func })
end

local function add_choice_text_conditional_raw(scriptname, title, data, test)
	if not noncombat_choice_texts[title] then noncombat_choice_texts[title] = {} end
	table.insert(noncombat_choice_texts[title], { test = test, data = data, scriptname = scriptname })
end


function load_file(category, name)
	if category ~= "chat" then
		run_file_with_environment(name, {
			add_processor = function (file, func) add_processor_raw(name, file, func) end,
			add_printer = function (file, func) add_printer_raw(name, file, func) end,
			add_choice_text_conditional = function (title, tbl, func) add_choice_text_conditional_raw(name, title, tbl, func) end,
			add_choice_text = function (title, tbl) add_choice_text_conditional_raw(name, title, tbl, function() return true end) end,
			add_choice_itemtext = function (title, tbl) add_choice_text_conditional_raw(name, title, tbl, function() return true end) end,
			add_choice_function = function (title, f) add_choice_text_conditional_raw(name, title, f, function() return true end) end,
			add_interceptor = function () end,
			add_automator = function () end,
		})
	end
end

run_file_with_environment("loaders.lua", {
	load_file = load_file,
})

run_file_with_environment("user-loaders.lua", {
	load_file = load_file,
})

if path == "/charpane.php" then
	familiar_picture, familiar_weight = string.match(text, "<a target=mainpane href=\"familiar.php\" class=\"familiarpick\"><img src=\"http://images.kingdomofloathing.com/itemimages/([^\"]-).gif\" width=30 height=30 border=0></a><br>([0-9]+) lb")
	if not familiar_picture then
		familiar_picture, familiar_weight = string.match(text, "<a target=mainpane href=\"familiar.php\" class=\"familiarpick\"><img src=\"http://images.kingdomofloathing.com/itemimages/([^\"]-).gif\" width=30 height=30 border=0>.- <b>([0-9]+)</b> pound ") -- TODO-future: redo without .-?
	end
	familiar_weight = tonumber(familiar_weight)
end

if active and path == "/charpane.php" then
	text = text:gsub("(<td align=right>Meat:.-)(</table>)", "%1<!-- charpane compact text space -->%2")
	text = text:gsub("(src=\"http://images.kingdomofloathing.com/itemimages/hourglass.gif\".-</table>)", "%1<!-- charpane normal text space -->")

	text = text:gsub("(<a target=mainpane href=\"familiar.php\" class=\"familiarpick\"><img src=\"http://images.kingdomofloathing.com/itemimages/)([^\"]-)(.gif\" width=30 height=30 border=0></a><br>)([0-9]+)( lb.-)(</center>)", "%1%2%3%4%5<!-- charpane compact familiar text space type{%2} weight{%4} -->%6") -- TODO-future: redo without .-?
	text = text:gsub("(<a target=mainpane href=\"familiar.php\" class=\"familiarpick\"><img src=\"http://images.kingdomofloathing.com/itemimages/)([^\"]-)(.gif\" width=30 height=30 border=0>.- <b>)([0-9]+)(</b> pound .-)(</table></center>)", "%1%2%3%4%5<!-- charpane normal familiar text space type{%2} weight{%4} -->%6") -- TODO-future: redo without .-!

	if text:match("charpane compact text space ") then
		compact_charpane = true
	elseif text:match("charpane normal text space") then
		normal_charpane = true
	end
end




if not active then
	if requestpath == "/adventure.php" then
		zone = string.match(requestquery, "snarfblat=([0-9]+)")
-- 		print("setting zone", zone)
		if (zone) then
			set_fight_state("zone", tonumber(zone))
			set_ascension_state("adventure.lastzone", tonumber(zone))
		end
	end
end




for x in text:gmatch("var onturn = ([0-9]+);") do
	combat_round = tonumber(x)
end
monster_name = string.match(text, "<span id='monname'>(.-)</span>")
if path == "/fight.php" then
	local z = get_fight_state("zone")
	if z ~= "" then
		adventure_zone = tonumber(z)
	end
end

if monster_name and query:match("ireallymeanit") then
	new_fight_started = true
end

adventure_title = string.match(text, [[<tr><td style="color: white;" align=center bgcolor=blue><b>([^<]*)</b></td></tr>]])
choice_adventure_number = tonumber(string.match(text, [[<input type=hidden name=whichchoice value=([0-9]+)>]]))
adventure_result = string.match(text, [[<td style="color: white;" align=center bgcolor=blue><b>Adventure Results:</b></td></tr><tr><td style="padding: 5px; border: 1px solid blue;"><center><table><tr><td><center><b>([^<]*)</b>]])

if not active then -- TODO: move to other file
	semis = get_semirare_encounters()
	for _, x in pairs(semis) do
		if (monster_name and new_fight_started and monster_name:match(x)) or adventure_title == x or adventure_result == x then
			print("SEMIRARE!!!", x)
			set_ascension_state("fortune cookie numbers", "")
			set_ascension_state("last semirare encounter", x)
			set_ascension_state("last semirare turn", get_turns_this_run())
		end
	end
end

fight_is_over = nil
if path == "/fight.php" then
	if (string.match(text, "state%['fightover'%] = true;")) then
		fight_is_over = true
	else
		fight_is_over = false
	end
end

function run_functions(target, pagetext)
	if not active then
		for _, processor in pairs(processors[target] or {}) do
--~ 			x = os.clock()
			getfenv(processor.f).text = pagetext
			processor.f()
--~ 			print("processor...", target, processor.scriptname, os.clock() - x)
		end
	else
		for _, printer in pairs(printers[target] or {}) do
--~ 			x = os.clock()
			getfenv(printer.f).text = pagetext
			printer.f()
			pagetext = getfenv(printer.f).text
--~ 			print("printer...", target, printer.scriptname, os.clock() - x)
		end
	end
	return pagetext
end

text = run_functions(path, text)

if path == "/fight.php" then
	text = string.gsub(text, [[(<td valign=center><img src="http://images.kingdomofloathing.com/itemimages/)([^"]+.gif)(" width=30 height=30 alt="[^"]+" title=")([^"]+)("></td><td valign=center>)(.-)(</td></tr>)]], function (pre, itemimage, mid, title, td, msg, post)
--~ 		print("item use", msg)
		item_image = itemimage
		item_name = title
		msg = run_functions("used combat item", msg)
		item_image = nil
		item_name = nil
		return pre .. itemimage .. mid .. title .. td .. msg .. post
	end)
end

if path == "/fight.php" then
	text = string.gsub(text, "(<center><table class=\"item\" style=\"float: none\" rel=\")([^\"]*)(\"><tr><td><img src=\"http://images.kingdomofloathing.com/itemimages/)([^\"]+.gif)(\" alt=\"[^\"]*\" title=\")([^\"]*)(\" class=hand onClick='descitem%([0-9]+%)'></td><td valign=center class=effect>)(You acquire .-)(</td></tr></table></center>)", function (pre, rel, mid1, image, mid2, title, mid3, dropinfo, post)
--~ 		print("item capture", pre, rel, mid, dropinfo, post)
		item_image = image
		item_name = title
		msg = run_functions("item drop", dropinfo)
-- 		print("item capture", pre, rel, mid, dropinfo, post)
--~ 		local msg = pre .. rel .. mid .. "<span style=\"color: darkgreen\">" .. dropinfo .. "</span>" .. post
--~ 		if string.match(rel, "u=u") then
--~ 			msg = pre .. rel .. mid .. "<span style=\"color: darkgreen\">" .. dropinfo .. "</span> [use]" .. post
--~ 			http://localhost:18481/inv_use.php?pwd=xxx&which=3&whichitem=3236
--~ 		elseif string.match(rel, "u=q") then
--~ 			msg = pre .. rel .. mid .. "<span style=\"color: darkgreen\">" .. dropinfo .. "</span> [equip]" .. post
--~ 			http://localhost:18481/inv_equip.php?pwd=xxx&which=2&action=equip&whichitem=2813
--~ 		end
		return pre .. rel .. mid1 .. image .. mid2 .. title .. mid3 .. msg .. post
	end)
end

if path == "/fight.php" then
--~ 	if (string.match(text, "<!%-%-familiarmessage%-%-><center><table>(.-)</table></center>")) then -- TODO-future: redo using commong familiar action event
	text = text:gsub([[(<!%-%-familiarmessage%-%-><center><table>.-</table></center>)]], function (msg)
		familiarmessage_picture = msg:match([[<!%-%-familiarmessage%-%-><center><table><tr><td align=center valign=center><img src="http://images.kingdomofloathing.com/itemimages/([^"]+).gif" width=30 height=30></td>]])
		if familiarmessage_picture then
			msg = run_functions("familiar message: " .. familiarmessage_picture, msg)
		end
		msg = run_functions("familiar message", msg)
		return msg
	end)
end

--~ if not active and path == "/fight.php" then
--~ 	setup_combat_skills()
--~ end

if not active and fight_is_over == true then
	reset_fight_state()
end

if active and path == "/charpane.php" then
	print_charpane_lines()
end

return text
